Bug Hunting Session
Bug 125481 - Preferred font order for Korean locale
Summary: Preferred font order for Korean locale
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:6.4.0 target:6.3.0.1
Keywords:
Depends on:
Blocks: CJK-Korean Fonts-Locale
  Show dependency treegraph
 
Reported: 2019-05-25 01:49 UTC by DaeHyun Sung
Modified: 2019-06-11 15:25 UTC (History)
1 user (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description DaeHyun Sung 2019-05-25 01:49:25 UTC
Description:

I follow up the "Preferred font order for Japanese locale" tdf#14751

I watched the LibreOffice Source code
unotools/source/config/fontcfg.cxx

 #define FALLBACKFONT_UI_SANS_KOREAN "SunGulim;BaekmukGulim;Gulim;Roundgothic;Arial Unicode MS;Lucida Sans Unicode;gnu-unifont;Andale Sans UI"


In Korea, SunGulim font is retired.
It was Linux distribution 
 Nowadays, can't found the many of Linux distributions (such as Ubuntu, )

Now, Many of Linux distribution, default Korean font became a Noto Sans CJK fonts.

Also, Mac OSX and Windows also changed default fonts. gulim to 나눔고딕 and 맑은고딕.

If I'll check specific Korean font environment on many of platforms, I'll submit the source code, change default fonts for Korean locale on LibreOFfice.

Actual Results:
font priority is wrong?

Expected Results:
Nowaday's Using Korean fonts on platforms(Linux, Mac OSX, Windows)


Reproducible: Always


User Profile Reset: No



Additional Info:
Comment 1 DaeHyun Sung 2019-05-25 01:50:50 UTC
I follow up the "Preferred font order for Japanese locale" tdf#114751
Comment 2 DaeHyun Sung 2019-05-26 06:55:04 UTC
In May 26, 2019,
LibreOffice Asia Conference Day2,  "CJK HackFest"

I discuss about Font ordering and fallbackfonts with Japanese contributor Abe and Taiwanese contributor Mark Hung. 

I showed the font rendering bugs about Japanese kanji(shinjitai/新字体), then Japanese & Taiwanese Contributors.

VCL.xcu's Korean Font list.


belows are Windows fonts
batang, batangche, dotum, dotumche, gulim, gulimche, gungsuh, gungsuhche, myeongjo



Belows are retired Korean font. (Maybe, Sun Microsystems Solaris OS or Sun Microsystem's Java Korean font?)

belows are Sun Solaris fonts
sunbatang(썬바탕), sundotum(썬돋움), sungulim(썬굴림), sungungseo(썬궁서), sunheadline(썬헤드라인), sunmokpan(썬목판)
sunyeopseo(썬엽서), suncrystal(썬크리스탈), sunsaemmul(썬샘물), sunbaeksong(썬백송) kodig(썬고딕), roundgothic(썬 둥근고딕)
(Check the Oracle site: https://docs.oracle.com/cd/E19504-01/802-7789/6ibcsnfar/index.html )


belows are Hancom’s fonts(maybe check commercial or non-commercial)
haansoftdotum, haansoftbatang

belows are commercial fonts

1. HanYang System Co., Limited (now Hanyang Information & Communications Co., Ltd))
hygothic, hygraphic, newgulim, hygungso, hyhaeseo, hymyeongjolightk, hymyeongjoextra
hysinmyeongjo, hyheadline, hygothicextra, hy목판l, hypost, hy엽서m, hy센스l, hy크리스탈m, hyshortsamul, hy백송b


2. 휴먼시스템(Human System)
yetr(휴먼옛체, HWP and MS word default installed font)

모리스시스템[http://www.morrisdesign.co.kr ] (Manual : http://fontpia.co.kr/new/cc/packege_menual.pdf )
mdsol(MD솔체),mdgaesung(MD개성체), mdart(MD아트), mdeasop(md이솝), mdalong(MD아롱)

below item don't know about license. (only retired software includes the Korean fonts)

magicr(magic R)

so, I'll delete the commercial and sun-family fonts on core/officecfg/registry/data/org/openoffice/VCL.xcu.
Comment 3 DaeHyun Sung 2019-05-26 07:00:32 UTC
Also, former Korean devloper and contributor don't distinguish Sans-family fonts and Serif-family fonts. 

So, I'll add new FLOSS fonts and delete commercial fonts and retired-os fonts.
(Also MacOS Korean fonts are missing from the list.)
Comment 4 DaeHyun Sung 2019-05-26 07:02:39 UTC
I think It related two Korean font rendering bugs both tdf#121527 and tdf#123061
Comment 5 DaeHyun Sung 2019-06-01 13:15:38 UTC
After Day2 Hackfest, I have just submitted Korean font configs, based on font config discussion that day.


- Set Noto Sans CJK KR as the 1st priority. 
- Set Nanum-series font as the 2nd priority, Such as NanumGothic(나눔고딕),NanumMyeongjo(나눔명조)
- Set KoPub-series font that Korea Publisher Society(한국출판인회의) and Ministry of 
  Culture, Sports and Tourism, Republic of Korea(문화체육관광부) are released
- for Windows vista and later versions, Add default Korean font, Malgun Gothic(맑은고딕)
- for Mac OSX, add default Korean font Apple SD Gothic Neo(Korean: 애플 SD 산돌고딕 Neo) 
- for Mac OSX, Also add Mac OSX fonts Apple Gothic(애플고딕),AppleMyungjo(애플명조)
- remove Sun-style fonts(Maybe Sun StarOffice's legacy)
- remove Hy(한양)-series fonts(Hancom HWP package's font, proprietary font-series) 

Modern Linux distribution's default Korean font-families are Noto Sans&Noto Serif-family
Before Noto Sans font released, UnFont-family was Linux distribition default Korean font.
Early Linux distribution's default Korean font: Baekmuk-family.

Sun-series font rarely use in Korean Linux distribution. 


ps. 
Noto Fonts(Modern Korean All OS default fonts)  https://www.google.co.kr/get/noto/
Source Han Sans https://fonts.adobe.com/fonts/source-han-sans-korean
Source Han Serif https://source.typekit.com/source-han-serif/kr/
Nanum-series font https://hangeul.naver.com/font
KoPub-series font http://www.kopus.org/biz/electronic/font.aspx
UnFont(Many of Linux distribution's default Korean font) http://kldp.net/unfonts/release/
Baekmuk Font(Early Linux distribution's Korean default font  http://kldp.net/baekmuk/



tdf#125481 changed font order for Korean locale
 https://gerrit.libreoffice.org/73307
Comment 6 Commit Notification 2019-06-08 20:19:58 UTC
DaeHyun Sung committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/0fd3610979a3116ca15377f3450f7794e768d937%5E%21

tdf#125481 changed font order for Korean locale

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Roman Kuznetsov 2019-06-09 07:27:52 UTC
DaeHyun Sung is this bug fixed? If yes then change status to RESOLVED FIXED please
Comment 8 DaeHyun Sung 2019-06-10 13:24:11 UTC
I checked Linux and Windows, It almost resolved.
But, Now, I'm building LibreOffice on MacOSX.

After checking LibreOffice on MacOSX, I'll change status to RESOLVED FIXED and want to closed.

(In reply to Roman Kuznetsov from comment #7)
> DaeHyun Sung is this bug fixed? If yes then change status to RESOLVED FIXED
> please
Comment 9 Commit Notification 2019-06-11 07:56:27 UTC
DaeHyun Sung committed a patch related to this issue.
It has been pushed to "libreoffice-6-3":

https://git.libreoffice.org/core/+/319263a3778d0ab06f1d207b61c63d5e8483899d%5E%21

tdf#125481 changed font order for Korean locale

It will be available in 6.3.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 DaeHyun Sung 2019-06-11 14:21:26 UTC
Today, I checked it on MacOSX

It changed it.